require 'uri'
class NormalizeHttpProxySetting < ActiveRecord::Migration[7.0]
  def up
    setting = Setting.find_by(name: 'http_proxy')
    return unless setting

    parsed_url = URI(setting.value)
    return unless parsed_url.userinfo

    Setting.find_or_create_by(name: 'http_proxy_username').update(value: parsed_url.user)
    Setting.find_or_create_by(name: 'http_proxy_password').update(value: parsed_url.password)
    parsed_url.userinfo = ''
    setting.update(value: parsed_url.to_s)
  end

  def down
    username = Setting.find_by(name: 'http_proxy_username')
    password = Setting.find_by(name: 'http_proxy_password')
    if username&.value.present? && password&.value.present?
      setting = Setting.find_by(name: 'http_proxy')
      parsed_url = URI(setting.value)
      parsed_url.user = username.value
      parsed_url.password = password.value
      setting.update(value: parsed_url.to_s)
      username.destroy
      password.destroy
    end
  end
end
